#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=roundoffice_3069728.ico
#AutoIt3Wrapper_UseX64=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.14.5
 Author				: Jemboy (c)2021
 Script name		: Office 2010 Starter Downloader v1.0
 Script Function	: Download Office 2010 Starter installation files for offline installation (without internet).

 23/03/2021 -	Added check if size of downloaded files match with the expected size (from on webpage).
				Changed some minor text (errors) and visual parts.
				Added dummy progressbar wheb looking for lates Office 2010 version.


 You are allowed to use this script in anyway execept asking money for it.
 In return, I ask you to donate at least € 1 or $1 to an organization against cancer in your country. E.g https://www.kwf.nl/donatie/donation

#ce ----------------------------------------------------------------------------


#include <Array.au3>
#include <File.au3>
#include <MsgBoxConstants.au3>
#include <InetConstants.au3>
#include <WinAPIFiles.au3>
#include <GUIConstantsEx.au3>
#include <FontConstants.au3>
#include <ProgressConstants.au3>
#include <SendMessage.au3>
#include <WindowsConstants.au3>
#include <GUIMenu.au3>

Dim $aArray[0]
Dim $bArray[0]
$sTitle = "Office 2010 Starter Downloader v1.0.1"
Global $iRadio_Count = 36						; Set the number of radios (Max value is 36!)
Global $aRadio_IDs[$iRadio_Count + 1], $iRow=0, $twelfrow=0
Global $LangArr [37]=["Arabic (ar-sa)","Bulgarian (bg-bg)","Chinese [Simplified] (zh-cn)","Chinese (zh-tw)","Croatian (hr-hr)","Czech (cs-cz) *","Danish (da-dk)","Dutch (nl-nl)","English (en-us)","Estonian (et-ee)", _
			"Finnish(fi-fi)","French (fr-fr)","German (de-de)","Greek (el-gr)","Hebrew (he-il)","Hindi(hi-in)","Hungarian (hu-hu)","Italian (it-it)","Japanese(ja-jp)","Kazakh (kk-kz)","Korean (ko-kr)", _
			"Latvian (lv-lv)","Lithuanian (lt-lt)","Norwegian [Bokmål] (nb-no)","Polish (pl-pl)","Portuguese [Brazil] (pt-br)","Portuguese (pt-pt)","Romanian (ro-ro)","Russian (ru-ru)","Serbian (sr-latn-cs)", _
			"Slovak (sk-sk)","Slovenian (sl-si)","Spanish (es-es)","Swedish (sv-se)","Thai (th-th)","Turkish (tr-tr)","Ukrainian (uk-ua)"]

$hGUI = GUICreate($sTitle, 550, 525)

GUICtrlCreateLabel("Please select your language for downloading the " & @CRLF & "Microsoft Office 2010 (Starter) installation files:", 30, 15, 500, 60)
GUICtrlSetFont (-1, 12, $FW_SEMIBOLD,$GUI_FONTNORMAL ,"", $ANTIALIASED_QUALITY )
If @Compiled then
	GUISetIcon (@ScriptFullPath)
else
	If FileExists (@ScriptDir & "\" & "roundoffice_3069728.ico") then GUISetIcon (@ScriptDir & "\" & "roundoffice_3069728.ico")
EndIf
$hButton = GUICtrlCreateButton("Start Downloading", 375, 475, 150, 25)

For $i = 1 To $iRadio_Count
	$iRow=Int (($i-1)/12)
	$twelfrow=$iRow * 12
	;MsgBox (0,"","$i =  " & $i & @CRLF & "i$Row = " & $iRow & @CRLF & "12row = " & $twelfrow)
    $aRadio_IDs[$i] = GUICtrlCreateRadio($LangArr[$i], 30 + ($iRow *175), 32 + (($i-$twelfrow)* 32), 175, 30)
Next
GUICtrlSetState  ($aRadio_IDs[7],$GUI_CHECKED)					; Set Dutch as default
GUISetState(@SW_SHOW)

$LangChoosen = False
$SelLang = 0

While not $LangChoosen
    Switch GUIGetMsg()
        Case $GUI_EVENT_CLOSE
            ExitLoop
        Case $hButton
            $sResult = ""
            For $i = 1 To $iRadio_Count
                If GUICtrlRead($aRadio_IDs[$i]) = 1 Then
                    ;MsgBox(0, "You selected: ", "Radio: " & $i)
					$SelLang = $i
					$LangChoosen = True
					;GuiSetState(@SW_DISABLE, $hGUI)
                    ExitLoop
                EndIf
            Next
    EndSwitch
WEnd

If $SelLang<>0 Then
	$TempLang = $LangArr[$SelLang]
	$Lang = StringMid ($TempLang, StringInStr ($TempLang,"(") +1, StringInStr ($TempLang,")")-StringInStr ($TempLang,"(")-1)
	;MsgBox (0,$sTitle,"Selected language is: " & $Lang)
Else
	MsgBox($MB_SYSTEMMODAL + $MB_ICONWARNING, $sTitle, "No Language was selected! Can not proceed without language selection.")
	Beep (500,250)
	Exit
EndIf

$DLPath = @ScriptDir & "\bin\" & $Lang
If not (FileExists($DLPath)) then DirCreate ( $DLPath)

;$Lang="en-us"
$bDigit = "1000"
If _URLStatus("http://c2r.microsoft.com/ConsumerC2R/" & $Lang & "/14.0.4763." & $bDigit & "/descriptor.xml")<>200 Then
	$Answ = MsgBox ($MB_YESNOCANCEL,$sTitle,"The versionnumber of Office 2010 Starter (" & $Lang & ") has changed." & @CRLF & "Locate new number and download ?")
	If $Answ<>$IDYes Then
		MsgBox (0,$sTitle,"Language download Office 2010 Starter (" & $Lang & ") not available." & @CRLF & "You choose not to look for new version." _
		 & @CRLF & @CRLF & "Program will exit.")
		Exit
	EndIf



	$hGUIPB = GUICreate($sTitle, 300, 85,-1,-1,BitXOR($WS_EX_TOOLWINDOW,$WS_EX_WINDOWEDGE))				;Melba - https://www.autoitscript.com/forum/topic/104153-loading-progress-bar/?tab=comments#comment-737094
	GUICtrlCreateProgress(10, 10, 200, 20, $PBS_MARQUEE)
	_SendMessage(GUICtrlGetHandle(-1), $PBM_SETMARQUEE, True, 50)
	GUICtrlCreateLabel ("Looking for latest version of Office 2010 Starter (" & $Lang & ")...",10,35)
	GUISetState()

	$bDigit = ReturnBDigit ($Lang)
	;GUISetCursor($old_cursor, 1, $hGUI)
	GUIDelete ($hGUIPB)
	If $bDigit<>0 Then
		MsgBox (0,$sTitle,"New version for Office 2010 Starter (" & $Lang & ") found: " & $bDigit)
	Else
		MsgBox (0,$sTitle,"Could not find recent version of Office 2010 Starter (" & $Lang & ")." & @CRLF & @CRLF & "Program will be exited.")
		Exit
	EndIf
EndIf


$DLPath = @ScriptDir & "\bin\" & $Lang
If not (FileExists($DLPath)) then DirCreate ( $DLPath)

$hDownload = InetGet("http://c2r.microsoft.com/ConsumerC2R/" & $Lang & "/14.0.4763." & $bDigit & "/descriptor.xml", $DLPath & "\" & "descriptor.xml" , $INET_FORCERELOAD,  $INET_DOWNLOADWAIT )
$dlErr= @error
If $dlErr<>0 then
	MsgBox($MB_SYSTEMMODAL + $MB_ICONWARNING, $sTitle, "Error while downloading 'descriptor.xml'. @error: " & $dlErr)
	Beep (500,250)
	Exit
EndIf


; Read the current script file into an array using the variable defined previously.Use UBound() to find the size of the array.
If Not _FileReadToArray(@ScriptDir & "\bin\" & $Lang & "\" & "descriptor.xml", $aArray, 0) Then
    MsgBox($MB_SYSTEMMODAL + $MB_ICONWARNING, $sTitle, "There was an error reading 'descriptor.xml'. @error: " & @error) ; An error occurred reading the current script file.
	Exit
EndIf

For $t=UBound ($aArray)-1 to 0 step -1
	If not (StringInStr($aArray[$t],'http://c2r')) then _ArrayDelete ($aArray, $t)
Next


;Add extra files to Download Array
_ArrayAdd ($bArray,"http://c2r.microsoft.com/ConsumerC2R/" & $Lang & "/14.0.4763." & $bDigit & "/autorun.inf")
_ArrayAdd ($bArray,"http://c2r.microsoft.com/ConsumerC2R/" & $Lang & "/14.0.4763." & $bDigit & "/launchofficeintl.dll")
_ArrayAdd ($bArray,"http://c2r.microsoft.com/ConsumerC2R/" & $Lang & "/14.0.4763." & $bDigit & "/Office.exe")
_ArrayAdd ($bArray,"http://c2r.microsoft.com/ConsumerC2R/" & $Lang & "/14.0.4763." & $bDigit & "/PackageProperties.xml")
_ArrayAdd ($bArray,"http://c2r.microsoft.com/consumerC2R/" & $Lang & "/14.0.4763." & $bDigit & "/setupconsumerc2rolw.exe")

For $t=0 to UBound ($aArray)-1
	$aArray [$t]= StringReplace ($aArray [$t],Chr(34),"@")

	While (StringInStr($aArray[$t],'http://c2r')<>0)
		;$hPos =StringInStr($aArray[$t],'http://c2r')
		$hPos = StringInStr($aArray[$t],"@http")
		;MsgBox (0,"", StringLeft ($aArray[$t],$hPos-1) & " -- hPos =" & $hPos)


		;$aArray[$t]= StringReplace ($aArray [$t],StringLeft ($aArray[$t],$hPos-1)," ")
		$ePos = StringInStr($aArray[$t],"@",  $STR_NOCASESENSE ,1,$hPos+1)
		$hStr = StringMid ($aArray[$t],$hPos,$ePos-$hPos+1)
		$aArray[$t] = StringReplace ($aArray [$t],$hStr,"")
		$hStr = StringReplace ($hStr,"@","")
		_ArrayAdd ($bArray, $hStr)
		;MsgBox (0,"", $hStr)
		;Exit
	WEnd
Next


;_ArrayDisplay($bArray)					; Check created download list.
$STCid = SplashTextOn($sTitle, "Office 2010 Starter (" & $Lang & ")" & @CRLF & @CRLF & "Downloading files: " & "Dummyfile.dfb" & " (" & 0+1 & "/" & UBound ($bArray) &  ")", 750, 100, -1, -1, $DLG_TEXTLEFT + $DLG_MOVEABLE , "", 16)
For $t=0 to UBound ($bArray)-1
	 ;$hDownload = InetGet($aArray[$t], $DLPath, $INET_FORCERELOAD,  $ePos = StringInStr($aArray[$t],"@",  $STR_NOCASESENSE ,1,$hPos+1) )
	 $stPos = StringInStr($bArray[$t],"/",  $STR_NOCASESENSE ,-1)
	 $FN= StringMid ($bArray[$t], $stPos+1, StringLen($bArray[$t]) - $stPos+1)

	SplashTextOn($sTitle, "Office 2010 Starter (" & $Lang & ")" & @CRLF & @CRLF & "Downloading files: " & $FN & " (" & $t+1 & "/" & UBound ($bArray) &  ")", 750, 100, -1, -1, $DLG_TEXTLEFT + $DLG_MOVEABLE , "", 16)


	ControlSetText ( $sTitle, "", $STCid, "Office 2010 Starter (" & $Lang & ")" & @CRLF & @CRLF & "Downloading files: " & $FN & " (" & $t+1 & "/" & UBound ($bArray) &  ")")
	$UserQuit = False
	Do
		$iSize = InetGetSize($bArray[$t])								; get the filesize program needs to download, to check if download was OK
		$hDownload = InetGet($bArray[$t], $DLPath & "\" & $FN , $INET_FORCERELOAD,  $INET_DOWNLOADWAIT )
		If $iSize<$hDownload then $iSize = InetGetSize($bArray[$t]) 	; Sometimes the first $iSize get's a size of 0 bytes, this line retries to get the file size, if iSize < hDownload
		Beep (500,150)
		If $hDownload<$iSize Then
			$AnswD = MsgBox ($MB_YESNO + $MB_TOPMOST,$sTitle,"The file '" & $FN & "' was NOT downloaded completely." & @CRLF & "Original size  : " & $iSize & " bytes." & @CRLF & "Downloaded size: " & $hDownload & " bytes." & @CRLF & _
									"The download was -> " & $iSize - $hDownload & " bytes <- less then expected." & @CRLF & @CRLF  & "Do you want to download this file again ?")
			If $AnswD<>$IDYes Then
				SplashOff ()
				MsgBox (0,$sTitle,"You have chose to quit due to a download error." & @CRLF & "Your internet connection may not be stable!" & @CRLF & @CRLF & "The downloads have NOT been completed succesfully!")
				Beep (250, 150)
				Exit
			EndIf
		ElseIf  $hDownload>$iSize Then
			$AnswD = MsgBox ($MB_CANCELTRYCONTINUE + $MB_TOPMOST,$sTitle,"The file '" & $FN & "' is bigger then expected." & @CRLF & "Expected size  : " & $iSize & " bytes." & @CRLF & "Downloaded size: " & $hDownload & " bytes." & @CRLF & _
									"The download was -> " & $hDownload-$iSize & " bytes <- more then expected."& @CRLF & "The file may been downloaded 100%, but we can not confirm it." & @CRLF & @CRLF  & _
									"Cancel = Quit program   -   Try Again = Download the file again  -  Continue = Accept file as is." & @CRLF & @CRLF & "Please make your choice ?")
			Select
				Case $AnswD = $IDCANCEL
					SplashOff ()
					MsgBox (0,$sTitle,"You have chose to quit due to a download error." & @CRLF & @CRLF & @CRLF & "Your downloads may NOT have been complety succesfull!")
					Beep (250, 150)
					Exit
				Case $AnswD = $IDTRYAGAIN
					Sleep (1)  ; Do nothing, this will automatically rettry the download
				Case $AnswD = $IDCONTINUE
					$UserQuit = True
			EndSelect
		EndIf
	Until ($hDownload=$iSize) or ($UserQuit=True)
Next

Download_KB2598285 ()							; Download update needed to get Office 2010 Starter working on Windows 10
WriteReadMe ()									; Write README.TXT (install instructions)
SplashOff()
MsgBox (0,$sTitle,"Office 2010 Starter (" & $Lang & ") has been downloaded." & @CRLF & @CRLF & "Please read README.TXT for instructions how to install!")
Beep (500,250)
Beep (500,250)

GUIDelete($hGUI)								; Delete the previous GUI and all controls.

Exit


Func Download_KB2598285 ()		;http://download.windowsupdate.com/d/msdownload/update/software/crup/2013/09/click2run-x-none_f74703316deaa94b7b7e72bfcf7bd718910e26a4.cab
	Local $DKB_OK=True
	$KBUrl = "http://download.windowsupdate.com/d/msdownload/update/software/crup/2013/09/click2run-x-none_f74703316deaa94b7b7e72bfcf7bd718910e26a4.cab"
	$hDownload = InetGet($KBUrl, $DLPath & "\" & "click2run-x-none_f74703316deaa94b7b7e72bfcf7bd718910e26a4.cab" , $INET_FORCERELOAD,  $INET_DOWNLOADWAIT )
	$DKBErr =@error
	If $DKBErr=0 Then
		UnZip($DLPath & "\" & "click2run-x-none_f74703316deaa94b7b7e72bfcf7bd718910e26a4.cab",  $DLPath & "\" & "Updates")
	Else
		MsgBox (0,$sTitle,"Downloading KB2598285 failed, please Google this KB article and download the file manually." & @CRLF & "Without this update Office 2010 Starter won't work on your computer.")
	EndIf
EndFunc

Func ReturnBDigit ($sLangRBD)
	For $t=0 to 50
		$BuildNum = 1000 + $t
		;MsgBox (0,$sTitle,"URL = " & "http://c2r.microsoft.com/ConsumerC2R/" & $sLangRBD & "/14.0.4763." & $BuildNum & "/descriptor.xml")
		$Res = _URLStatus("http://c2r.microsoft.com/ConsumerC2R/" & $sLangRBD & "/14.0.4763." & $BuildNum & "/descriptor.xml")
		;Beep (500,200)
		If $Res="200" then Return $BuildNum
	Next
	Return 0
EndFunc

Func _URLStatus($aURL)				;(c)2016 by VIP   - https://www.autoitscript.com/forum/topic/182454-url-status-check/?tab=comments#comment-1310379
    $oHTTP = ObjCreate("WinHttp.WinHttpRequest.5.1")
    $oHTTP.Open("HEAD", $aURL, False)
    If @error Then Return SetError(1, 0, 0)
    $oHTTP.Send()
    If @error Then Return SetError(2, 0, 0)
    Return $oHTTP.Status
EndFunc   ;==>_URLStatus

;--------------------------------------------------------------------------------------
;https://www.autoitscript.com/forum/topic/139249-unzip-a-zip/
;(c)2019 Nine
;--------------------------------------------------------------------------------------
Func UnZip($sZipFile, $sDestFolder)
  If Not FileExists($sZipFile) Then Return SetError (1) ; source file does not exists
  If Not FileExists($sDestFolder) Then
    If Not DirCreate($sDestFolder) Then Return SetError (2) ; unable to create destination
  Else
    If Not StringInStr(FileGetAttrib($sDestFolder), "D") Then Return SetError (3) ; destination not folder
  EndIf
  Local $oShell = ObjCreate("shell.application")
  Local $oZip = $oShell.NameSpace($sZipFile)
  Local $iZipFileCount = $oZip.items.Count
  If Not $iZipFileCount Then Return SetError (4) ; zip file empty
  FileDelete ($sDestFolder & "\*.*")					; Delete the files, to not get Overwrite popup. "Yes to all" does not work (Micrsoft confirmed).
  For $oFile In $oZip.items
    $oShell.NameSpace($sDestFolder).copyhere($ofile,4)	; 4=No GUI, 16=Yes to all  -   https://docs.microsoft.com/en-us/windows/win32/shell/folder-copyhere
  Next
EndFunc   ;==>UnZip


Func WriteReadMe ()
	Local $RMT[19]=["To install Office 2010 Starter, go to into the 'bin' folder and to the right language directory.", _
				"E.g. '.../bin/de-de' is the folder for the German Office 2010 Starter installation files.", _
				" ", _
				"1. Run SetupConsumerC2ROLW.exe with right mouse click 'Run as Administrator'", _
				"2. After the installation, double click click2run-x-none.msp (KB2598285) within de update folder and restart", _
				"   your computer. https://www.catalog.update.microsoft.com/Search.aspx?q=2598285", _
				" ", _
				"After the above reboot, Office 2010 Starter will work on Windows 10 20H2.", _
				" ", _
				"To copy the shortcuts to your desktop:", _
				"a. Go to search and type 'Word'", _
				"b. At 'Microsoft Word Starter 2010', click on 'Open file location'", _
				"c. Now copy the shortcuts (Word and Excel) to your desktop.", _
				" ", _
				"Office 2010 Starter works with a virtualization technology, which creates a ", _
				"system drive Q:. If you are already using drive Q: then Office 2010 Starter won't start.", _
				" ", _
				"Office 2010 starter files have been unavailable for some time, but Microsoft quietly ", _
				"activated the downloads again a few years ago."]

	Local $hFileOpen = FileOpen($DLPath & "\" & "README.TXT", $FO_OVERWRITE)
	For $t=0 to Ubound ($RMT)-1
		FileWriteLine($hFileOpen,$RMT[$t])
	Next
	FileClose($hFileOpen)
EndFunc
